
# lineMask.py
# Daniel Schroeder, 2011-11-20

# Reads a given file and a repeating pattern of which lines
# to print, and prints the desired lines to standard output.
# For example, running
#   python lineMask.py foo.txt 00101
# would print out lines 5*i + 2 and 5*i + 4 (indexing lines starting
# at 0) of foo.txt for each i until all lines of the file have
# been read.

# This is meant for extracting evenly-distributed training and
# testing sub-corpora from the Europarl corpora.

import sys

def printFileSubset(fileName, mask):
    i = 0

    fObj = open(fileName, 'r')
    line = fObj.readline()

    while len(line) > 0:
        if mask[i] == "1":
            sys.stdout.write(line)

        i = (i + 1) % len(mask)
        line = fObj.readline()

    fObj.close()

def main():
    if len(sys.argv) != 3:
        print "usage: %s file mask" % sys.argv[0]
        return

    printFileSubset(sys.argv[1], sys.argv[2])

if __name__ == "__main__":
    main()
