'''
human_sample_creator.py
'''
from __future__ import division
import sys
import random
DEBUGMODE = 0

def usage():
	print "human_sample_creator.py number of people sentences_per_person output_file_name number_of_input_files original_lang_file input_files*"
def inListofTuples(list, value, position):
	for tuple in list:
		if tuple and tuple[position] == value: return True
		
	return False

def main():
	argLength = len(sys.argv)
	if argLength < 7:
		usage()
		return
		
	##process arguments##
	
	numPpl = int(sys.argv[1])
	w = int(sys.argv[2])
	outputfilename = sys.argv[3]
	numInputFiles = int(sys.argv[4])
	originalLangFileName = sys.argv[5]
	inputfilenames = []
	for i in range(numInputFiles):
		#print sys.argv[6+i]
		try: inputfilenames.append(sys.argv[6+i])
		except IndexError:
			print "number of input files given did not match number of input files given"
			return
	
	##read all files into memory##
	
	originalLangFile = open(originalLangFileName)
	originalLangLines = originalLangFile.readlines()
	originalLangFile.close()
	originalLangLines[-1]+="\n"
	fileLength = len(originalLangLines)
	
	translationFiles = []
	for filename in inputfilenames:
		file = open(filename)
		lines = file.readlines()
		if len(lines) != fileLength:
			print "files of different length"
			return
		lines[-1]+="\n"
		translationFiles.append(lines)
		file.close()
	
	
	##calculate the partition matrix##
	
	numSentences = w*numPpl
	
	#round down the number of sentences used so that
	#for each source sentence, each translation is guaranteed
	#to be checked
	numUniqueSentences = numSentences//numInputFiles
	if numUniqueSentences > fileLength:
		print "not enough sentences"
		return
		
	#number of people vs work per person; each square holds a tuple indicating
	#the translation group and the sentence index
	sentenceMatrix = [[i for i in range(numUniqueSentences)] for j in range(numInputFiles)]
	partitionMatrix = [[None for i in range(w)] for j in range(numPpl)]
	currentFileIndex = 0
	currentSenIndex = 0
	skips = []
	br = False
	for senIndex in range(w):
		for p in range(numPpl):
			if currentSenIndex == numUniqueSentences:
				currentFileIndex+=1
				currentSenIndex = 0
			if inListofTuples(partitionMatrix[p], currentSenIndex, 1):
				skips.append((currentFileIndex, currentSenIndex))
				currentSenIndex+=1
			if currentFileIndex == numInputFiles:
				br = True
				break
			partitionMatrix[p][senIndex] = (currentFileIndex, currentSenIndex)
			currentSenIndex+=1
		if br: break
		
	for i in range(len(skips)):
		skipIndex = 0
		while inListofTuples(partitionMatrix[p], skips[skipIndex][1], 1):
			skipIndex+=1
		partitionMatrix[p][senIndex] = skips.pop(skipIndex)
		p+=1
		if p==numPpl:
			senIndex+=1
			p=0
	print sentenceMatrix
	print partitionMatrix
	
	##create the files based on the partitionMatrix##
	file = open("key"+outputfilename, "w")
	for p in range(numPpl):
		file.write(str(partitionMatrix[p])+"\r\n")
	file.close()
	
	for p in range(numPpl):
		file = open(outputfilename+str(p+1), "w")
		indices = partitionMatrix[p]
		for index in indices:
			if index:
				sentenceIndex = index[1]
				file.write(originalLangLines[sentenceIndex])
				file.write(translationFiles[index[0]][sentenceIndex])
				file.write("\r\n")
		file.close()
main()			