'''
partition.py
'''
import sys
import random
#random.seed(5)

def usage():
    print "Usage:"
    print "partition.py [filename 1] [filename 2] [number of lines desired] [outfile name 1] [outfile name 2]"

def main():
    if len(sys.argv) < 6: 
		usage()
		return
    filename1 = sys.argv[1]
    filename2 = sys.argv[2]
    sampleSize = int(sys.argv[3])
    outfilename1 = sys.argv[4]
    outfilename2 = sys.argv[5]

    file1 = open(filename1)
    lines1 = file1.readlines()
    file1.close()
    file2 = open(filename2)
    lines2 = file2.readlines()
    file2.close()



    if len(lines1) != len(lines2):
        print "incompatible input files..."
        print "file length of "+filename1+": ",
        print len(lines1)
        print "file length of "+filename2+": ",
        print len(lines2)
        return
    
    newlines1 = []
    newlines2 = []
    for i in range(len(lines1)):
        newline1 = lines1[i].strip("\r\n")
        if newline1 != "" or True: newlines1.append(newline1)
        newline2 = lines2[i].strip("\r\n")
        if newline2 != "" or True: newlines2.append(newline2)

    if len(newlines1) != len(newlines2):
        print "error removing newlines"
        return
    lines1 = newlines1
    lines2 = newlines2
    
    if sampleSize >= len(lines1):
        print "Sample size too large"
        print "size of file: "+str(len(lines1))
        print "sample size: "+sampleSize
        return

    population = [i for i in range(len(lines1))]
    sampleLines = random.sample(population, sampleSize)

    outfile1 = open(outfilename1, "w")
    outfile2 = open(outfilename2, "w")

    for i in range(sampleSize-1):
        outfile1.write(lines1[sampleLines[i]]+"\n")
        outfile2.write(lines2[sampleLines[i]]+"\n")

    outfile1.write(lines1[sampleLines[i+1]])
    outfile2.write(lines2[sampleLines[i+1]])        

    outfile1.close()
    outfile2.close()

main()
